diff --git a/bin/build-helper b/bin/build-helper
index 5fd4941c..16ad67ee 100755
--- a/bin/build-helper
+++ b/bin/build-helper
@@ -217,6 +217,13 @@ eof
             | python3 -c 'import json; import sys; print(json.loads(sys.stdin.read())["id"])') \
             || exit 1
 
+        # upload archive and then signature
+        curl -H "Authorization: token ${token}" \
+             -H "Accept: application/vnd.github.manifold-preview" \
+             -H "Content-Type: application/x-gtar" \
+             --data-binary @${archivename} \
+            "https://uploads.github.com/repos/ungleich/cdist/releases/${repoid}/assets?name=${archivename}" \
+            || exit 1
         curl -H "Authorization: token ${token}" \
              -H "Accept: application/vnd.github.manifold-preview" \
              -H "Content-Type: application/pgp-signature" \
diff --git a/bin/build-helper.freebsd b/bin/build-helper.freebsd
index cea75afc..829fbf09 100755
--- a/bin/build-helper.freebsd
+++ b/bin/build-helper.freebsd
@@ -252,6 +252,13 @@ eof
             | python3 -c 'import json; import sys; print(json.loads(sys.stdin.read())["id"])') \
             || exit 1
 
+        # upload archive and then signature
+        curl -H "Authorization: token ${token}" \
+             -H "Accept: application/vnd.github.manifold-preview" \
+             -H "Content-Type: application/x-gtar" \
+             --data-binary @${archivename} \
+            "https://uploads.github.com/repos/ungleich/cdist/releases/${repoid}/assets?name=${archivename}" \
+            || exit 1
         curl -H "Authorization: token ${token}" \
              -H "Accept: application/vnd.github.manifold-preview" \
              -H "Content-Type: application/pgp-signature" \